#define 	F_CPU 12000000L	// Procesoriaus taktinis daznis, reikia delay.h
#include	<avr\io.h>		
#include 	<avr\interrupt.h>
#include	<avr\sleep.h>


volatile char krpt, kk, slow;

char trueHSL(char h)
{
long i;
i=(h*6375L)/1000L;
return i;
}

void HtoRGB(char x)
{
char r,g,b;

if (x>240) {x=240;}
if (x<41){
	r=255;
	g=trueHSL(x);;
	b=0;
	goto blogis;}
if (x<81){
	r=255-trueHSL(x-40);
	g=255;
	b=0;
	goto blogis;}
if (x<121){
	r=0;
	g=255;
	b=trueHSL(x-80);
	goto blogis;}
if (x<161){	
	r=0;
	g=255-trueHSL(x-120);
	b=255;
	goto blogis;}
if (x<201){
	r=trueHSL(x);
	g=0;
	b=255;
	goto blogis;}

	r=255;
	g=0;
	b=255-trueHSL(x-160);
	
blogis:
	OCR1A=g;
	OCR1B=b;
	OCR0=r;
}

//----------------------------------------------------------------------
void initAll(void)				
{
   	// DDR- kojyciu kryptis. Pas mumi diodai ne prie visu koju. Ziur schema.
	DDRB=_BV(PB3);		// PWM0 isejimas OC0/PB3.
	
	
	//NAUJAS, Timeris 0. Interupt ir 0 pwm.
	TCCR0=_BV(WGM00)|_BV(CS02)|_BV(CS02)|_BV(COM01)|_BV(COM00);

	
	
    /* Enable OC1A and OC1B as output. */
	// d5 ir d4, pas mega16 tai taimerio 1 isejimai.
    DDRD = _BV(PD5) | _BV(PD4);	
	
	
    /* Set PWM value to 0. */
    OCR1A = 0;
	OCR1B = 0;
	OCR0=0;

	// CS12,CS10-clck/64 prescaler for Counter 1
	TCCR1B=_BV (CS10)|_BV(CS11);

	
	// PWM8bit, PWM on both outputs.
	TCCR1A =  _BV (WGM10) | _BV(COM1A1) | _BV(COM1B1)| _BV(COM1A0) | _BV(COM1B0);


    /* Enable timer 0 overflow interrupt. */
    TIMSK = _BV (TOIE0);
    sei ();


}
//======================================================================

//---pertraukimas pagal taimeri 0----
ISR(TIMER0_OVF_vect) //timer overflow vector
{
slow++;
if (slow==2){
if (krpt==0) { kk++;
			if (kk==255) {krpt=255;}
			}
	else
			{kk--; 
			if (kk==0) {krpt=0;}
			}

 HtoRGB(kk);
 
 slow=0;
 }
}

//---pagrindine------
int main (void)			// Nuo cia prasideda.
{
							
    initAll();			// Sutvarkom portu kryptis
    do {					// Pagrindinis ciklas
			sleep_mode();
    } while (1);			// amzinas ciklas cia. Isejimo nera
}
